# NgDynaform

A Dynamic Form Builder for Angular.

## General options for each control

### Common field metadata properties

All fields support the following metadata. The missing properties will be 'filled oin' by dynaform's field-specific models, allowing forms to specifiued tersely.

| Property           	| Description                                                                   	| Default / Notes                                      	|
|--------------------	|-------------------------------------------------------------------------------	|------------------------------------------------------	|
| name               	| The FormControl name                                                          	| Derived from the key of the control's metadata object |
| type               	| The control type                                                              	| Text                                                 	|
| label              	| The controls's label                                                          	| UnCamelCased and spaced version of name              	|
| value              	| The control's initial value                                                                              	| Empty string                  |
| checkedValue       	| Value when checked*                                                           	| Checkboxes / Checkbuttons only                       	|
| default            	| Default value                                                                 	|                                                      	|
| placeholder        	| Optional placeholder text                                                     	|                                                      	|
| class              	| CSS classes to apply                                                          	| Single class (string) or array of classes (string[]) 	|
| id                 	| CSS id to apply                                                               	|                                                      	|
| disabled           	| Whether field is disbled                                                      	|                                                      	|
| change             	| Name of function in host component to call when value changes                 	|                                                      	|
| source             	| Location of data in model                                                      	| Same name and path. Used by model-mapper.            	|
| before             	| Ordering instruction - move before <name of another control in group>         	|                                                      	|
| after              	| Ordering instruction - move after <name of another control in group>          	|                                                      	|
| validators         	| Array of validator functions - following Angular FormControl API              	|                                                      	|
| asyncValidators    	| Array of async validator functions - following Angular FormControl API        	|                                                      	|
| valFailureMessages 	| Validation failure messages - display appropriate message if validation fails 	|                                                      	|

```
{
	firstName: {},
	lastName: {},
	telephoneNumber: {}
}
```

### Options metadata (selects, radios, checkbutton groups, etc)

Supply an array of values, an array of [calue, label] pairs, or an array of { value: <VALUE>, label: <LABEL> } objects. If you supply a aimple array of values, each value is used as both the value and label.

```
{
	firstName: {},
	lastName: {},
	telephoneNumber: {},
	country: { type: 'select', options: ['France', 'Germany', 'Italy', 'Norway', 'Spain', 'UK'] }
}
```


## Grouping related controls using containers

Related cpontrols can be grouped in containers.

### Seeding groups with shared options

### Repeating groups

## The built-in model mapper

TO ADD.




